; TTYTrans 0.1
; Copyright (C) 2006 Daniel Mewes (danielmewes@onlinehome.de)
; Feel free to distribute, modify and/or use this code in any way you want.

ORG 100h
BITS 16
CPU 8086

section .bss

buffer resb 256
fileLength resw 1
fileHandle resw 1
command resb 1
filename resb 256

section .text

mov ah, 09h
mov dx, welcomeMsg
int 21h

; Fill filename
mov cx, 256
mov si, filename
cleanFilename:
  mov byte [si], 0
  inc si
  loop cleanFilename

; Wait for the command byte
xor dx, dx
waitcmd:
  mov ah, 02h
  int 14h
  cmp al, "g"
  je gotCommand
  cmp al, "p"
  je gotCommand
  jmp short waitcmd

gotCommand:
  mov [command], al
  mov ah, 02h
  int 14h
  ; Read filename
  xor ch, ch
  mov cl, al
  mov dx, filename
  call readTty
  cmp byte [command], "p"
  je putCommand
  jmp getCommand

putCommand:
  ; Read file length
  mov cx, 2
  mov dx, fileLength
  call readTty
  mov ah, 09h
  mov dx, putMsg
  int 21h
  ; Create file
  call printFilename
  mov ah, 3Ch
  mov dx, filename
  int 21h
  mov [fileHandle], ax
  ; Receive data
  readNextBlock:
  mov cx, 256
  cmp cx, [fileLength]
  jng readFullBlock
  mov cx, [fileLength]
  readFullBlock:
  xor dx, dx
  mov ah, 01h
  mov al, 20h ; Ready
  int 14h
  waitForBlock:
    mov ah, 02h
    int 14h
    cmp al, 30h
    jne waitForBlock  
  mov dx, buffer
  call readTty
  sub [fileLength], ax
  mov bx, [fileHandle]
  mov cx, ax
  mov dx, buffer
  mov ah, 40h
  int 21h
  cmp word [fileLength], 0
  jne readNextBlock

  ; Close file
  mov bx, [fileHandle]
  mov ah, 3Eh
  int 21h
  mov ah, 09h
  mov dx, okMsg
  int 21h
  ; Return to DOS
  mov ah, 4Ch
  int 21h

getCommand:
  mov ah, 09h
  mov dx, getMsg
  int 21h
  ; Open file
  call printFilename
  mov ah, 3Dh
  mov al, 00h
  mov dx, filename
  int 21h
  mov [fileHandle], ax
  ; Send data
  sendNextBlock:
  mov bx, [fileHandle]
  mov cx, 256
  mov dx, buffer
  mov ah, 3Fh
  int 21h
  mov [fileLength], ax
  ; Send block length
  mov dx, fileLength
  mov cx, 2
  call writeTty
  cmp word [fileLength], 0
  je fileSent
  ; Send data block
  mov cx, [fileLength]
  mov dx, buffer
  call writeTty
  jmp sendNextBlock

  fileSent:
  ; Close file
  mov bx, [fileHandle]
  mov ah, 3Eh
  int 21h
  mov ah, 09h
  mov dx, okMsg
  int 21h
  ; Return to DOS
  mov ah, 4Ch
  int 21h

readTty:
  push cx
  mov si, dx
  xor dx, dx
  readChar:
    mov ah, 02h
    int 14h
    cmp ah, 0
    jne transError
    mov [si], al
    inc si
    loop readChar
  pop ax
  ret

writeTty:
  push cx
  mov si, dx
  xor dx, dx
  writeChar:
    mov al, [si]
    mov ah, 01h
    int 14h
;    cmp ah, 0
;    jne transError
    inc si
    loop writeChar
  pop ax
  ret

transError:
  mov ah, 09h
  mov dx, transErrorMsg
  int 21h
  mov ah, 4Ch
  int 21h


printFilename:
  push ax
  push dx
  mov si, filename
  printNext:
    mov ah, 02h
    mov dl, [si]
    int 21h
    inc si
    cmp byte [si], 0
    jne printNext
  pop dx
  pop ax
  ret

welcomeMsg db "Welcome to TTYTrans 0.1!", 10, 13, "Waiting for command", 10, 13, "$"
getMsg db "Sending file $"
putMsg db "Receiving file $"
okMsg db " Ok$"
transErrorMsg db " Failed$"
endChar db 1Ah
